PingOne Platform APIs

Create Sign-On Policy Action (PROGRESSIVE_PROFILING_FORM)

POST {{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions

The POST {{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions operation creates a new sign-on policy action resource. The priority property specifies the order in which this action (and its conditions) is evaluated when evaluating the policy. Property values range from 1 to {maxInt}. The action with a priority value of 1 is evaluated first.

The sample shows the request for a PROGRESSIVE_PROFILING_FORM action type.

If all attributes configured in the form for the progressive profiling action are defined as optional ("required": false), users can skip this action in the authentication flow.

Prerequisites

Request Model
Property Type Required

form.id

Object

Required

hidden

Boolean

Optional

preventMultiplePromptsPerFlow

Boolean

Required

priority

Integer

Required

promptIntervalSeconds

Integer

Required

type

String

Required

Refer to the Sign-on policy actions base data model for full property descriptions.

Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

Body

raw ( application/json )

{
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING_FORM",
    "hidden": false,
    "form": {
        "id": "{{formID}}"
    },
    "promptIntervalSeconds": 7776000,
    "preventMultiplePromptsPerFlow": true
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING_FORM",
    "hidden": false,
    "form": {
        "id": "{{formID}}"
    },
    "promptIntervalSeconds": 7776000,
    "preventMultiplePromptsPerFlow": true
}'
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""priority"": 40," + "\n" +
@"    ""type"": ""PROGRESSIVE_PROFILING_FORM""," + "\n" +
@"    ""hidden"": false," + "\n" +
@"    ""form"": {" + "\n" +
@"        ""id"": ""{{formID}}""" + "\n" +
@"    }," + "\n" +
@"    ""promptIntervalSeconds"": 7776000," + "\n" +
@"    ""preventMultiplePromptsPerFlow"": true" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions"
  method := "POST"

  payload := strings.NewReader(`{
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING_FORM",
    "hidden": false,
    "form": {
        "id": "{{formID}}"
    },
    "promptIntervalSeconds": 7776000,
    "preventMultiplePromptsPerFlow": true
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING_FORM",
    "hidden": false,
    "form": {
        "id": "{{formID}}"
    },
    "promptIntervalSeconds": 7776000,
    "preventMultiplePromptsPerFlow": true
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"priority\": 40,\n    \"type\": \"PROGRESSIVE_PROFILING_FORM\",\n    \"hidden\": false,\n    \"form\": {\n        \"id\": \"{{formID}}\"\n    },\n    \"promptIntervalSeconds\": 7776000,\n    \"preventMultiplePromptsPerFlow\": true\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING_FORM",
    "hidden": false,
    "form": {
      "id": "{{formID}}"
    },
    "promptIntervalSeconds": 7776000,
    "preventMultiplePromptsPerFlow": true
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING_FORM",
    "hidden": false,
    "form": {
      "id": "{{formID}}"
    },
    "promptIntervalSeconds": 7776000,
    "preventMultiplePromptsPerFlow": true
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions"

payload = json.dumps({
  "priority": 40,
  "type": "PROGRESSIVE_PROFILING_FORM",
  "hidden": False,
  "form": {
    "id": "{{formID}}"
  },
  "promptIntervalSeconds": 7776000,
  "preventMultiplePromptsPerFlow": True
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "priority": 40,\n    "type": "PROGRESSIVE_PROFILING_FORM",\n    "hidden": false,\n    "form": {\n        "id": "{{formID}}"\n    },\n    "promptIntervalSeconds": 7776000,\n    "preventMultiplePromptsPerFlow": true\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "priority": 40,
  "type": "PROGRESSIVE_PROFILING_FORM",
  "hidden": false,
  "form": {
    "id": "{{formID}}"
  },
  "promptIntervalSeconds": 7776000,
  "preventMultiplePromptsPerFlow": true
})

response = http.request(request)
puts response.read_body
let parameters = "{\n    \"priority\": 40,\n    \"type\": \"PROGRESSIVE_PROFILING_FORM\",\n    \"hidden\": false,\n    \"form\": {\n        \"id\": \"{{formID}}\"\n    },\n    \"promptIntervalSeconds\": 7776000,\n    \"preventMultiplePromptsPerFlow\": true\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

201 Created

{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/signOnPolicies/530a1d45-958b-425c-ba83-b61e3b2caf49/actions/e72f6337-7395-42a3-a94b-2d2623e0732d"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "signOnPolicy": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/signOnPolicies/530a1d45-958b-425c-ba83-b61e3b2caf49"
        },
        "form": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/forms/16731ae0-72c0-451a-9c58-ef969a76e973"
        }
    },
    "id": "e72f6337-7395-42a3-a94b-2d2623e0732d",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "type": "PROGRESSIVE_PROFILING_FORM",
    "hidden": false,
    "signOnPolicy": {
        "id": "530a1d45-958b-425c-ba83-b61e3b2caf49"
    },
    "priority": 40,
    "form": {
        "id": "16731ae0-72c0-451a-9c58-ef969a76e973"
    },
    "preventMultiplePromptsPerFlow": true,
    "promptIntervalSeconds": 7776000
}